var comentarios = new Class ({
	Implements: [Options, Events],
	options: {
		logueado:false,
		contenedor:'',
		url_comentarios:'',
		paginaActual:0,
		idComentario:'textoComentario',
		idConteo:'conteoCaracter'
	},
	initialize: function(options, manageTabsOptions){
		//if ( parseInt($('comentarios').value) == 1 )
		{
			this.servicio = null;
			var self = this;
			this.cuentaServicios = 0;
			this.uri = uri = location.href.toString().replace(/=/g, "?sigual?").replace(/&/g, "?amp?");
			//Inicializa el objeto
			this.setOptions(options);
			//Inicializa el objeto para manejar los tabs
			this.manageTabs = new manageTabs(manageTabsOptions);
			this.local = new comentarios_local({contenedor:this.options.contenedor, idComentario:this.options.idComentario, idConteo:this.options.idConteo, padre:this});
			this.twitter = new comentarios_twitter({tab:manageTabsOptions.arrayGeneral[1], contenedor:this.options.contenedor, idComentario:this.options.idComentario, idConteo:this.options.idConteo, padre:this});
			this.facebook = new comentarios_facebook({contenedor:this.options.contenedor, padre:this});
			$(this.options.contenedor).removeClass('oculto');
			if ( $('tw_path') != null )
			{
				$('header_comentarios').getElement('.tiny_url').removeClass('oculto');
				$('header_comentarios').getElement('.tiny_url span').set('html', $('tw_path').value);
			}
			$(this.options.contenedor).addEvent('requestLogin', function (usr, servicio, tipoServicio){
				self.nomServicio = tipoServicio;
				self.servicio = servicio;
				$$('.loginControles')[0].addClass('oculto');
				$$('.cajaComentarios')[0].removeClass('oculto');
				$$('.idUsuario span')[0].innerHTML = usr;
				if ( tipoServicio == 'local' )
				{
					self.manageTabs.show(1, null, false);
					self.limiteCaracteres = 300;
					if ( typeof(servicio.data.profile_image_url) != 'undefined' )
					{
						//self.imagenPerfil = servicio.data.profile_image_url;
						self.imagenPerfil = '/images/spacer.gif';
					}
				}
				else if ( tipoServicio == 'twitter' )
				{
					self.manageTabs.show(2, null, false);
					self.limiteCaracteres = 100;
					if ( typeof(servicio.data.profileImageUrl) != 'undefined' )
					{
						self.imagenPerfil = servicio.data.profileImageUrl;
					}
				}
				else if ( tipoServicio == 'facebook' )
				{
					self.manageTabs.show(3, null, false);
					self.limiteCaracteres = 300;
					if ( typeof(servicio.data.username) != 'undefined' )
					{
						self.imagenPerfil = 'http://graph.facebook.com/'+servicio.data.username+'/picture';
					}
					/*if ( typeof(servicio.data.pic_square) != 'undefined' )
					{
						self.imagenPerfil = servicio.data.pic_square;
					}*/
				}
				if ( typeof(self.imagenPerfil) != 'undefined' )
				{
					$$('.imagenPerfil')[0].getElement('img').set('src', self.imagenPerfil);
				}
				$(self.options.idComentario).addEvent('change', self.cuentaCaracteres.bind(self) );
				$(self.options.idComentario).addEvent('keyup', self.cuentaCaracteres.bind(self) );
				self.cuentaCaracteres.bind(self)();
			});
			$(this.options.contenedor).addEvent('requestLogout', function (){
				self.nomServicio = '';
				self.servicio = null;
				$$('.loginControles')[0].removeClass('oculto');
				$$('.cajaComentarios')[0].addClass('oculto');
				$$('.idUsuario span')[0].innerHTML = '';
				$$('.imagenPerfil')[0].getElement('img').set('src', '');
				self.imagenPerfil = '';
			});
			$$('.botonComenta')[0].addEvent('click', function(){
				if ( self.servicio != null )
				{
					self.comenta();
				}
			});
			this.manageTabs.addEvent('tabChanged', function(){
				if ( self.servicio != null )
				{
					self.servicio.logout();
				}
				if ( this.options.activa == 1 )
				{
					self.local.doLogin(true);
				}
				else if ( this.options.activa == 2 )
				{
					self.twitter.doLogin(true);
				}
			});
			$('portlet_comentarios').getElement('.logout').addEvent('click', function(){
				if ( self.servicio != null )
				{
					self.servicio.logout(true);
				}
			});
			this.paginado(this.options.paginaActual);
		}
	},
	comenta: function ()
	{
		var self = this;
		var opinion = $('textoComentario').value;
		var nombre = this.servicio.data.name;
		if ( this.nomServicio == 'twitter' )
		{
			var mail = "http://www.twitter.com/"+this.servicio.data.screenName;
		}
		else if ( this.nomServicio == 'local' )
		{
			var mail = this.servicio.data.screen_name;
		}
		else if ( this.nomServicio == 'facebook' )
		{
			//var mail = this.servicio.data.profile_url;
			var mail = this.servicio.data.link;
		}
		var grupo = '';
		var pagina = $('pagina_comentarios')?$('pagina_comentarios').value:0;
		var titulo = document.title;
		if ( opinion != "" )
		{
			var data = "Mcomentario=1&opinion_comentario="+ opinion+
				"&nombre_comentario="+nombre+
				"&mail_comentario="+mail+
				"&titulo_comentario="+titulo+
				"&grupo="+grupo+
				"&uri="+this.uri+
				"&pagina="+pagina+
				"&imagen="+(typeof(this.imagenPerfil)!='undefined'?this.imagenPerfil:'');
			new Request.JSON ({
				url:this.options.url_comentarios,
				noCache:true,
				data:data,
				onSuccess:function(responseJSON, responseText)
				{
					self.escribeComentarios(responseJSON);
				}
			}).send();
			this.servicio.update(opinion);
			$('textoComentario').value='';
			this.cuentaCaracteres();
		}
		else
		{
			alert("Debes llenar todos los campos para comentar!");
		}
	},
	paginado: function(pagina)
	{
		var self = this;
		var grupo = '';
			
		//var data = "comentarios=1&pagina="+pagina+"&uri="+this.uri+"&grupo="+grupo;
		var data = "comentarios=1&pagina="+pagina+"&uri="+this.uri+"&grupo="+grupo;
		new Request.JSON ({
			url:this.options.url_comentarios,
			noCache:true,
			data:data,
			onSuccess:function(responseJSON, responseText)
			{
				self.options.paginaActual = pagina;
				self.escribeComentarios(responseJSON);
			}
		}).send();
	},
	generaPaginado: function ( responseJSON )
	{
		var self = this;
		if (typeof(responseJSON.todosComentariosActivo) != 'undefined' && eval(responseJSON.todosComentariosActivo) != false)
		{
			var divMuestraTodosComentarios = new Element ('div', {
				'class':'divMuestraTodosComentarios',
				'html':'Todos los comentarios',
				'events':{
					'click':this.paginado.bind(self, 1)
				}
			}).inject($('resulta_comentarios'));
		}
		else if ( typeof(responseJSON.todosComentariosActivo) == 'undefined' && eval(responseJSON.cuantos) > eval(responseJSON.paginado) )
		{
			var numPaginas = parseInt(responseJSON.cuantos/responseJSON.paginado)+1;
			var divContenedorPaginado = new Element ('div', {
				'class':'divContenedorPaginado'
			});
			var divContenedorPaginadoCentrado = new Element ('div', {
				'style':'float:left'
			}).inject(divContenedorPaginado);
			var divPrimeraPagina = new Element ('div', {
				'class':'botonPaginadoControl',
				'html':'Primera',
				'events':{
					'click':this.paginado.bind(self, 1)
				}
			}).inject(divContenedorPaginadoCentrado);
			for ( i = 0; i < numPaginas; ++i )
			{
				if ( (i+1) == self.options.paginaActual )
				{
					var classPagina = 'botonPaginadoActual';
				}
				else
				{
					var classPagina = 'botonPaginado';
				}
				var pagina = new Element ('div', {
					'class':classPagina,
					'html':(i+1),
					'events':{
						'click':this.paginado.bind(self, (i+1))
					}
				}).inject(divContenedorPaginadoCentrado);
			}
			var divUltimaPagina = new Element ('div', {
				'class':'botonPaginadoControl',
				'html':'&Uacute;ltima',
				'events':{
					'click':this.paginado.bind(self, (numPaginas))
				}
			}).inject(divContenedorPaginadoCentrado);
			divContenedorPaginado.inject($('resulta_comentarios'));
			var anchoCentrado = $(divContenedorPaginadoCentrado).offsetWidth;
			$(divContenedorPaginadoCentrado).erase('style');
			$(divContenedorPaginadoCentrado).setStyles({
				'width':anchoCentrado+1,
				'height':20,
				'margin':'0 auto'
			});
		}
	},
	escribeComentarios: function(responseJSON)
	{
		var self = this;
		$('resulta_comentarios').innerHTML = '';
		this.generaPaginado(responseJSON);
		var headerComentarios = new Element ('div', {
			'class':'headerComentarios'
		}).inject($('resulta_comentarios'));
		var divConteoComentarios = new Element ('span', {
			'html':responseJSON.cuantos+'&nbsp;Comentario'+(responseJSON.cuantos>1||responseJSON.cuantos==0?'s':''),
			'class':'divConteoComentarios'
		}).inject(headerComentarios);
		responseJSON.comentarios.each(function(item, index){
			var divContenedorComentario = new Element ('div', {
				'class':'divContenedorComentario'
			});
			var divNumeroComentario = new Element ('div', {
				'class':'divNumeroComentario',
				'html':item.numero
			}).inject(divContenedorComentario);/*
			var imgPerfil = new Element('img', {
				'class':'imagenPerfilComentario',
				'src':item.imagen
			}).inject(divNumeroComentario);*/
			var columnaDerecha = new Element ('div', {
				'class':'columnaDerechaComentarios'
			}).inject(divContenedorComentario);
			var divUsuarioComentario = new Element ('div', {
				'class':'divUsuarioComentario',
				'html':"Lo dijo:<span>"+item.nombre+"</span>"
			}).inject(columnaDerecha);
			var divHoraComentario = new Element ('div', {
				'class':'divHoraComentario',
				'html':item.fecha
			}).inject(columnaDerecha);
			var divComentario = new Element ('div', {
				'class':'divComentario',
				'html':item.comentario
			}).inject(divContenedorComentario);
			var divControlesComentario = new Element ('div', {
				'class':'divControlesComentario'
			}).inject(divContenedorComentario);
			var divCalificacionComentario = new Element ('div', {
				'class':'divCalificacionComentario',
				'html':'Calificar:'
			}).inject(divControlesComentario);
			var divStarsComentario = new Element ('div', {
				'class':'divContenedorEstrellas'
			}).inject(divCalificacionComentario);
			var stars = new starsRating ({
				'numberStars':5,
				'numberActive':item.rating,
				'numberRates':item.cuantos,
				'callback':self.rateComentario,
				'anchorDiv':divStarsComentario,
				'normalClass':'starNormal',
				'overClass':'starOver',
				'activeClass':'starActive',
				'idStars':item.idOpinion,
				'parent':self
			});
			var divReportarComentario = new Element ('div', {
				'class':'divReportarComentario',
				'html':'Reportar comentario:'
			}).inject(divControlesComentario);
			if ( Cookie.read ('report'+item.idOpinion) == null )
			{
				var classReporte = 'reporteNormal';
			}
			else
			{
				var classReporte = 'reporteActivo';
			}
			var reportarComentario = new Element ('div', {
				'class': classReporte,
				'events':{
					'mouseenter':function()
					{
						if ( Cookie.read ('report'+item.idOpinion) == null )
						{
							this.removeClass('reporteNormal');
							this.addClass('reporteActivo');
						}
					},
					'mouseleave': function()
					{
						if ( Cookie.read ('report'+item.idOpinion) == null )
						{
							this.addClass('reporteNormal');
							this.removeClass('reporteActivo');
						}
					},
					'click': function ()
					{
						if ( Cookie.read ('report'+item.idOpinion) == null )
						{
							var data = "Mreporta=1&id_opinion="+item.idOpinion+"&uri="+self.uri;
							var myself = this;
							new Request ({
								url:self.options.url_comentarios,
								noCache:true,
								data:data,
								onSuccess: function ()
								{
									var path = new URI(location.href.toString());
									Cookie.write('report'+item.idOpinion, 1, {path:path.parsed.directory, duration:365});
									myself.removeClass('clickeable');
									myself.removeClass('reporteNormal');
									myself.addClass('reporteActivo');
									myself.removeEvent('mouseenter');
									myself.removeEvent('mouseleave');
								}
							}).send();
						}
					}
				}
			}).inject(divReportarComentario);
			if ( Cookie.read ('report'+item.idOpinion) == null )
			{
				reportarComentario.addClass('clickeable');
			}
			divContenedorComentario.inject($('resulta_comentarios'));
		});
		this.generaPaginado(responseJSON);
	},
	rateComentario: function ( rate, id, cuantos, actualRate, control )
	{
		if ( Cookie.read ('rate'+id) == null )
		{
			var self = this;
			var data = "Mcalifica=1&calificacion="+(rate+1)+"&id_opinion="+id+"&cuantos="+cuantos+"&calificacion_v="+actualRate;
			new Request ({
				url:this.options.url_comentarios,
				noCache:true,
				data:data,
				onSuccess: function ()
				{
					var path = new URI(location.href.toString());
					Cookie.write('rate'+id, 1, {path:path.parsed.directory, duration:365});
					control.options.numberActive = parseInt(((control.options.numberRates*control.options.numberActive)+(rate+1))/(++control.options.numberRates));
					control.buildStars();
				}
			}).send();
		}
	},
	giveMeHeight: function (Elem)
	{
		try 
		{
			return Elem.offsetHeight;
		}
		catch (e) 
		{
			try
			{
				return Elem.scrollHeight;
			}
			catch (e)
			{
				return 0;
			}
		} 
	},
	cuentaCaracteres: function ()
	{
		var actuales = $(this.options.idComentario).value.length;
		$(this.options.idComentario).value = $(this.options.idComentario).value.toString().substr(0, this.limiteCaracteres);
		actuales = $(this.options.idComentario).value.length;
		$(this.options.idConteo).innerHTML = this.limiteCaracteres-actuales;
	}
});