var manageTabs = new Class ({
	Implements: [Options, Events],
	options: {
		arrayGeneral:null,
		selected: '',
		normal:'',
		oculto:'',
		activa:0
	},
	initialize: function(options){
		var self=this;
		this.setOptions(options);
		this.options.arrayGeneral.each(function(item, index){
			$(item+"_tab").addEvent('click', function(e){
				self.show(this.id.replace('_tab', ''), e);
			});
		});
		this.show(this.options.activa, false);
	},
	show: function(idTab, e, dispararEvento)
	{
		if ( typeof(dispararEvento) == 'undefined' || dispararEvento != false )
		{
			dispararEvento = true;
		}
		if ( idTab == 'next' )
		{
			this.options.activa = ((this.options.activa)%(this.options.arrayGeneral.length))+1;
		}
		else if ( this.isNumeric(idTab) )
		{
			this.options.activa = idTab;
		}
		else if ( this.options.arrayGeneral.indexOf(idTab) != -1 )
		{
			this.options.activa = this.options.arrayGeneral.indexOf(idTab)+1;
		}
		if ( this.options.arrayGeneral.length > 0 && this.options.activa <= this.options.arrayGeneral.length && this.options.activa > 0 )
		{
			for ( var i = 0; i < this.options.arrayGeneral.length; ++i )
			{
				if ( this.options.activa == (i+1) )
				{
					$(this.options.arrayGeneral[i]+"_tab").addClass(this.options.selected);
					$(this.options.arrayGeneral[i]+"_tab").removeClass(this.options.normal);
					$(this.options.arrayGeneral[i]+"_contenido").removeClass(this.options.oculto);
				}
				else
				{
					$(this.options.arrayGeneral[i]+"_tab").removeClass(this.options.selected);
					$(this.options.arrayGeneral[i]+"_tab").addClass(this.options.normal);
					$(this.options.arrayGeneral[i]+"_contenido").addClass(this.options.oculto);
				}
			}
			if ( dispararEvento )
			{
				this.fireEvent('tabChanged', e);
			}
		}
		return this.options.activa;
	},
	isNumeric: function (input)
	{
	   return typeof(input) == 'number' && (input - 0) == input;
	}
});
